{ IE 3.0 look implemented by Gilles Pelletier (micro.controle@bigfoot.com). }
{ Delphi 3 conversion by Andy Chentsov (andy@t52.hep.by) and Jordan Russell.
  Changes marked by +++ }
{Original source code for the DBNavigator (C) by Borland
*********************************************************
DBNavigator97 (Release 2.1)
*********************************************************
Source modified and enhanced for use with the Toolbar97 components
from Jordan Russell (http://members.aol.com/jordanr7).

The DBNavigator97 works exactly like the original Delphi 2.0 DB Navigator.
When putting it on a Toolbar97,the buttons will be separated from each
other when running the application,and the toolbar can be resized with
correct "button wrapping" instead of keeping one unseparated block.

I didn't test it with Delphi 1. If there are problems I suppose they have
to do with the database implementation.

Expect for the original DBNavigator source parts by Borland,this source is
(C) by Arsne von Wyss (avonwyss@beaulieu-software.ch)}

unit DBNav97;

interface

uses
        SysUtils,Windows,Messages,Classes,Controls,Forms,ExtCtrls,DB,DBTables,Graphics,Buttons,DBCtrls,TB97;

{+++ Determine Delphi/C++Builder version }
{$IFNDEF VER90}  { if it's not Delphi 2.0 }
  {$IFNDEF VER93}  { and it's not C++Builder 1.0 }
    {$DEFINE DBNav97Delphi3}  { then it must be Delphi 3 or higher
                                (or a future version of C++Builder) }
  {$ENDIF}
{$ENDIF}

type
   TNavButton97=class;
   TNavDataLink97=class;


{TDBNavigator97}
   TDBNavigator97=class(TCustomPanel)
   private
           FDataLink: TNavDataLink97;
           FVisibleButtons,FEnabledButtons: TButtonSet;
           FHints: TStrings;
           FCaptions: TStrings;
           FDisplayMode: TButtonDisplayMode;
           FWordWrap: Boolean;
           ButtonWidth: Integer;
           MinBtnSize: TPoint;
           FOnNavClick: ENavClick;
           FocusedButton: TNavigateBtn;
           FConfirmDelete,FOpaque: Boolean;
           function GetDataSource: TDataSource;
           procedure SetDataSource(Value: TDataSource);
           procedure InitButtons;
           procedure InitHints;
           procedure SetCaptions(Value: TStrings);
           procedure InitCaptions;
           procedure SetDisplayMode (Value: TButtonDisplayMode);
           procedure SetWordWrap (Value: Boolean);
           function GetGlyph(index: integer): TBitmap;
           procedure SetGlyph(index: integer; Value: TBitmap);
           procedure InitFont;
           procedure InitGlyphNumber;
           procedure Click(Sender: TObject);
           procedure BtnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
           procedure SetVisible(Value: TButtonSet);
           procedure SetEnabled(Value: TButtonSet);
           procedure AdjustSize(var W: Integer; var H: Integer);
           procedure SetHints(Value: TStrings);
           procedure SetOpaque(Value: Boolean);
           procedure WMSize(var Message: TWMSize);  message WM_SIZE;
           procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
           procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
           procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
           procedure WMEraseBackground(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
           procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
   protected
           Buttons: array[TNavigateBtn] of TNavButton97;
           procedure DataChanged;
           procedure EditingChanged;
           procedure ActiveChanged;
           procedure Loaded; override;
           procedure KeyDown(var Key: Word; Shift: TShiftState); override;
           procedure Notification(AComponent: TComponent; Operation: TOperation); override;
           procedure GetChildren(Proc: TGetChildProc);
           procedure SetParent(AParent: TWinControl); override;
   public
           constructor Create(AOwner: TComponent); override;
           destructor Destroy; override;
           procedure SetBounds(ALeft,ATop,AWidth,AHeight: Integer); override;
           procedure BtnClick(Index: TNavigateBtn);
   published
           property DataSource: TDataSource read GetDataSource write SetDataSource;
           property VisibleButtons: TButtonSet read FVisibleButtons write SetVisible       default
                           [nbFirst,nbPrior,nbNext,nbLast,nbInsert,nbDelete,nbEdit,nbPost,nbCancel,nbRefresh];
           property EnabledButtons: TButtonSet read FEnabledButtons write SetEnabled       default
                           [nbFirst,nbPrior,nbNext,nbLast,nbInsert,nbDelete,nbEdit,nbPost,nbCancel,nbRefresh];
           property Opaque: Boolean read FOpaque write SetOpaque default True;
           property Align;
           property Enabled;
           property Hints: TStrings read FHints write SetHints;
           property Captions: TStrings read FCaptions write SetCaptions;
           property DisplayMode: TButtonDisplayMode read FDisplayMode write SetDisplayMode default dmBoth;
           property WordWrap: Boolean read FWordWrap write SetWordWrap default True;
           property GlyphFirstBtn: TBitmap index 0 read GetGlyph write SetGlyph;
           property GlyphPriorBtn: TBitmap index 1 read GetGlyph write SetGlyph;
           property GlyphNextBtn: TBitmap index 2 read GetGlyph write SetGlyph;
           property GlyphLastBtn: TBitmap index 3 read GetGlyph write SetGlyph;
           property GlyphInsertBtn: TBitmap index 4 read GetGlyph write SetGlyph;
           property GlyphDeleteBtn: TBitmap index 5 read GetGlyph write SetGlyph;
           property GlyphEditBtn: TBitmap index 6 read GetGlyph write SetGlyph;
           property GlyphPostBtn: TBitmap index 7 read GetGlyph write SetGlyph;
           property GlyphCancelBtn: TBitmap index 8 read GetGlyph write SetGlyph;
           property GlyphRefreshBtn: TBitmap index 9 read GetGlyph write SetGlyph;
           property Font;
           property ParentShowHint;
           property PopupMenu;
           property ConfirmDelete: Boolean read FConfirmDelete write FConfirmDelete default True;
           property ShowHint;
           property Visible;
           property OnResize;
   end;

{TNavButton97}
   TNavButton97=class(TToolbarButton97)
   private
           FIndex: TNavigateBtn;
           FNavStyle: TNavButtonStyle;
           FRepeatTimer: TTimer;
           procedure TimerExpired(Sender: TObject);
   protected
           procedure Paint; override;
           procedure MouseDown(Button: TMouseButton; Shift: TShiftState;   X,Y: Integer); override;
           procedure MouseUp(Button: TMouseButton; Shift: TShiftState;     X,Y: Integer); override;
   public
           destructor Destroy; override;
           property NavStyle: TNavButtonStyle read FNavStyle write FNavStyle;
           property Index : TNavigateBtn read FIndex write FIndex;
   end;

{TNavDataLink97}
   TNavDataLink97=class(TDataLink)
   private
           FNavigator: TDBNavigator97;
   protected
           procedure EditingChanged; override;
           procedure DataSetChanged; override;
           procedure ActiveChanged; override;
   public
           constructor Create(ANav: TDBNavigator97);
           destructor Destroy; override;
   end;

procedure Register;

implementation

{$R DBNav97.Res}

uses
        BDE,Clipbrd,DBConsts,Dialogs;

{TDBNavigator97}

const
        {+++ unused!}{BtnStateName: array[TNavGlyph] of PChar=('EN','DI');}
        BtnTypeName: array[TNavigateBtn] of PChar=('FIRST','PRIOR','NEXT','LAST',
                        'INSERT','DELETE','EDIT','POST','CANCEL','REFRESH');

        BtnHintId: array[TNavigateBtn] of {+++}{$IFDEF DBNav97Delphi3}String{$ELSE}Word{$ENDIF}=(SFirstRecord,SPriorRecord,SNextRecord,SLastRecord,
                        SInsertRecord,SDeleteRecord,SEditRecord,SPostEdit,SCancelEdit,SRefreshRecord);

procedure TDBNavigator97.SetParent(AParent: TWinControl);
var
        I: TNavigateBtn;
begin
        inherited;
        if not (csDesigning in ComponentState) then
                for I:=High(Buttons) downto Low(Buttons) do
                        with Buttons[I] do begin
                                Visible:=False;
                                Top:=Top;
                                Left:=Left;
                                Parent:=self.Parent;
                                Visible:=True;
                        end;
end;

procedure TDBNavigator97.SetEnabled(Value: TButtonSet);
var
        I: TNavigateBtn;
begin
        FEnabledButtons:=Value;
        for I:=Low(Buttons) to High(Buttons) do
                Buttons[I].Enabled:=I in Value;
        Invalidate;
end;

procedure TDBNavigator97.SetOpaque(Value: Boolean);
var
        I: TNavigateBtn;
begin
        if Value<>FOpaque then begin
                FOpaque:=Value;
                if Value then
                        ControlStyle := ControlStyle + [csOpaque]
                else
                        ControlStyle := ControlStyle - [csOpaque];
                for I:=Low(Buttons) to High(Buttons) do
                        Buttons[I].Opaque:=Value;
                Invalidate;
        end;
end;

procedure TDBNavigator97.WMEraseBackground(var Message: TWMEraseBkgnd);
begin
end;

constructor TDBNavigator97.Create(AOwner: TComponent);
begin
        inherited;
        ControlStyle:=ControlStyle-[csAcceptsControls,csSetCaption]+[csOpaque];
        FDataLink:=TNavDataLink97.Create(Self);
        FVisibleButtons:=[nbFirst,nbPrior,nbNext,nbLast,nbInsert,nbDelete,nbEdit,nbPost,nbCancel,nbRefresh];
        FEnabledButtons:=FVisibleButtons;
        FHints:=TStringList.Create;
        FCaptions:=TStringList.Create;
        FWordWrap:=True;
        FOpaque:=True;
        InitButtons;
        BevelOuter:=bvNone;
        BevelInner:=bvNone;
        Width:=450;
        Height:=55; 
        ButtonWidth:=0;
        FocusedButton:=nbFirst;
        FConfirmDelete:=True;
        if not (csDesigning in ComponentState) then
                Visible:=False;
end;

destructor TDBNavigator97.Destroy;
begin
        FDataLink.Free;
        FHints.Free;
        FCaptions.Free;
        FDataLink:=nil;
        inherited;
end;

procedure TDBNavigator97.InitButtons;
var
        I: TNavigateBtn;
        Btn: TNavButton97;
        X: Integer;
begin
   MinBtnSize:=Point(20,18);
   X:=0;
   for I:=Low(Buttons) to High(Buttons) do begin
           Btn:=TNavButton97.Create(self);
           with Btn do begin
                if (csDesigning in ComponentState) then
                        Parent:=Self;
                Index:=I;
                SetBounds(X,0,MinBtnSize.X,MinBtnSize.Y);

                if (Glyph.Empty) then begin
                   { +++ Changed resource name, and added IFDEF }
                   {$IFDEF DBNav97Delphi3}
                   Glyph.LoadFromResourceName (HInstance, Format('dbn_%s97', [BtnTypeName[I]]));
                   {$ELSE}
                   Glyph.Handle:=LoadBitmap(HInstance,PChar(Format('dbn_%s97',[BtnTypeName[I]])));
                   {$ENDIF}
                   NumGlyphs:=2;
                   end;
                Enabled:=True;
                Opaque:=FOpaque;
                OnClick:=self.Click;
                OnMouseDown:=BtnMouseDown;
                Visible:=I in FVisibleButtons;
                Layout:=blGlyphTop;
                WordWrap:=FwordWrap;
           end;
           Buttons[I]:=Btn;
           X:=X+MinBtnSize.X;
   end;
   InitHints;
   InitCaptions;
   InitFont;
   Buttons[nbPrior].NavStyle:=Buttons[nbPrior].NavStyle+[nsAllowTimer];
   Buttons[nbNext].NavStyle:=Buttons[nbNext].NavStyle+[nsAllowTimer];
end;

procedure TDBNavigator97.InitHints;
var
        I: Integer;
        J: TNavigateBtn;
begin
        for J:=Low(Buttons) to High(Buttons) do begin
                Buttons[J].Hint:={+++}{$IFNDEF DBNav97Delphi3}LoadStr{$ENDIF}(BtnHintId[J]);
                {+++}{ following line added so that default hints correctly
                       appear on buttons when Hints property is unassigned }
                Buttons[J].ShowHint:=ShowHint;
        end;
        J:=Low(Buttons);
        for I:=0 to (FHints.Count-1) do begin
                if FHints.Strings[I]<>'' then
                        with Buttons[J] do begin
                                Hint:=FHints.Strings[I];
                                ShowHint:=self.ShowHint;
                        end;
                if J=High(Buttons) then
                        Exit;
                Inc(J);
        end;
end;

procedure TDBNavigator97.SetHints(Value: TStrings);
begin
        FHints.Assign(Value);
        InitHints;
end;
procedure TDBNavigator97.InitCaptions;
var
        I: Integer;
        J: TNavigateBtn;
begin
        for J:=Low(Buttons) to High(Buttons) do begin
                Buttons[J].Caption:={+++}{$IFNDEF DBNav97Delphi3}LoadStr{$ENDIF}(BtnHintId[J]);
        end;
        J:=Low(Buttons);
        for I:=0 to (FCaptions.Count-1) do begin
                if FCaptions.Strings[I]<>'' then
                        with Buttons[J] do begin
                                Caption:=FCaptions.Strings[I];
                        end;
                if J=High(Buttons) then
                        Exit;
                Inc(J);
        end;
end;

procedure TDBNavigator97.SetWordWrap(Value: Boolean);
var
  J: TNavigateBtn;
begin
     FWordWrap:=Value;
     for J:=Low(Buttons) to High(Buttons) do begin
                Buttons[J].WordWrap:= FWordWrap;
     end;
end;

procedure TDBNavigator97.SetCaptions(Value: TStrings);
begin
        FCaptions.Assign(Value);
        InitCaptions;
end;

function TDBNavigator97.GetGlyph(index: integer): TBitmap;
var
        I: TNavigateBtn;
begin
  Result := Buttons[Low(Buttons)].Glyph;
  for I:=Low(Buttons) to High(Buttons) do
     if (index = Ord(I)) then
        Result := Buttons[I].Glyph;
end;

procedure TDBNavigator97.SetGlyph (index: integer; Value: TBitmap);
var
  I: TNavigateBtn;
begin
  for I:=Low(Buttons) to High(Buttons) do
    if (index = Ord(I)) then begin
      Buttons[I].Glyph:=Value;
      Invalidate;
    end;
end;

procedure TDBNavigator97.SetDisplayMode (Value: TButtonDisplayMode);
var
        J: TNavigateBtn;
begin
  if FDisplayMode <> Value then begin
    FDisplayMode := Value;
    for J:=Low(Buttons) to High(Buttons) do begin
       Buttons[J].DisplayMode:=Value;
       end;
    end;
end;

procedure TDBNavigator97.InitFont;
var
        J: TNavigateBtn;
begin
    for J:=Low(Buttons) to High(Buttons) do begin
       Buttons[J].Font.Assign(Font);
       end;
end;

procedure TDBNavigator97.InitGlyphNumber;
var
        J: TNavigateBtn;
        Glyphs: TNumGlyphs97;
begin
    for J:=Low(Buttons) to High(Buttons) do
       if Buttons[J].Glyph.Width mod Buttons[J].Glyph.Height = 0 then begin
         Glyphs := Buttons[J].Glyph.Width div Buttons[J].Glyph.Height;
         if Glyphs > High(TNumGlyphs97) then Glyphs := 1;
         Buttons[J].NumGlyphs:=Glyphs;
       end;
end;

procedure TDBNavigator97.GetChildren(Proc: TGetChildProc);
begin
end;

procedure TDBNavigator97.Notification(AComponent: TComponent; Operation: TOperation);
begin
        inherited;
        if (Operation=opRemove) and Assigned(FDataLink) and     (AComponent=DataSource) then
                DataSource:=nil;
end;

procedure TDBNavigator97.SetVisible(Value: TButtonSet);
var
        I: TNavigateBtn;
        W,H: Integer;
begin
        W:=Width;
        H:=Height;
        FVisibleButtons:=Value;
        for I:=Low(Buttons) to High(Buttons) do
                Buttons[I].Visible:=I in FVisibleButtons;
        AdjustSize(W,H);
        if (W<>Width) or (H<>Height) then
                inherited SetBounds(Left,Top,W,H);
        Invalidate;
end;

procedure TDBNavigator97.AdjustSize(var W: Integer; var H: Integer);
var
        Count: Integer;
        MinW: Integer;
        I: TNavigateBtn;
        Space,Temp,Remain: Integer;
        X,XOffset,YOffset: Integer;
begin
        if (csLoading in ComponentState) or (Buttons[nbFirst]=nil) then
                Exit;
        if (csDesigning in ComponentState) then begin
                XOffset:=0;
                YOffset:=0;
        end else begin
                XOffset:=Left;
                YOffset:=Top;
        end;
        Count:=0;
        for I:=Low(Buttons) to High(Buttons) do
                if Buttons[I].Visible then
                        Inc(Count);
        if Count=0 then
                Inc(Count);
        MinW:=Count*MinBtnSize.X;
        if W<MinW then
                W:=MinW;
        if H<MinBtnSize.Y then
                H:=MinBtnSize.Y;
        ButtonWidth:=W div Count;
        Temp:=Count*ButtonWidth;
        if Align=alNone then
                W:=Temp;
        X:=0;
        Remain:=W-Temp;
        Temp:=Count div 2;
        for I:=Low(Buttons) to High(Buttons) do
                if Buttons[I].Visible then begin
                        Space:=0;
                        if Remain<>0 then begin
                                Dec(Temp,Remain);
                                if Temp<0 then begin
                                        Inc(Temp,Count);
                                        Space:=1;
                                end;
                        end;
                        Buttons[I].SetBounds(XOffset+X,YOffset,ButtonWidth+Space,Height);
                        Inc(X,ButtonWidth+Space);
                end else
                        Buttons[I].SetBounds (XOffset+Width+1,YOffset,ButtonWidth,Height);
        if not (csDesigning in ComponentState) then
                Visible:=False;
end;

procedure TDBNavigator97.SetBounds(ALeft,ATop,AWidth,AHeight: Integer);
var
        W,H: Integer;
begin
        W:=AWidth;
        H:=AHeight;
        AdjustSize (W,H);
        inherited SetBounds (ALeft,ATop,W,H);
end;

procedure TDBNavigator97.WMSize(var Message: TWMSize);
var
        W,H: Integer;
begin
        inherited;
        W:=Width;
        H:=Height;
        AdjustSize(W,H);
        if (W<>Width) or (H<>Height) then
                inherited SetBounds(Left,Top,W,H);
        Message.Result:=0;
end;

procedure TDBNavigator97.Click(Sender: TObject);
begin
        BtnClick(TNavButton97(Sender).Index);
end;

procedure TDBNavigator97.BtnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
var
        OldFocus: TNavigateBtn;
begin
        OldFocus:=FocusedButton;
        FocusedButton:=TNavButton97 (Sender).Index;
        if TabStop and (GetFocus<>Handle) and CanFocus then begin
                SetFocus;
                if (GetFocus<>Handle) then
                        Exit;
        end else if TabStop and (GetFocus=Handle) and (OldFocus<>FocusedButton) then begin
                Buttons[OldFocus].Invalidate;
                Buttons[FocusedButton].Invalidate;
        end;
end;

procedure TDBNavigator97.BtnClick(Index: TNavigateBtn);
begin
        if (DataSource<>nil) and (DataSource.State<>dsInactive) then
                with DataSource.DataSet do
                        case Index of
                        nbPrior: Prior;
                        nbNext: Next;
                        nbFirst: First;
                        nbLast: Last;
                        nbInsert: Insert;
                        nbEdit: Edit;
                        nbCancel: Cancel;
                        nbPost: Post;
                        nbRefresh: Refresh;
                        nbDelete:
                                if (not FConfirmDelete) or (MessageDlg({$IFNDEF DBNav97Delphi3}LoadStr{$ENDIF}(SDeleteRecordQuestion),mtConfirmation,mbOKCancel,0)<>idCancel) then
                                        Delete;
                        end;
        if not (csDesigning in ComponentState) and Assigned(FOnNavClick) then
                FOnNavClick(Self,Index);
end;

procedure TDBNavigator97.WMSetFocus(var Message: TWMSetFocus);
begin
        Buttons[FocusedButton].Invalidate;
end;

procedure TDBNavigator97.WMKillFocus(var Message: TWMKillFocus);
begin
        Buttons[FocusedButton].Invalidate;
end;

procedure TDBNavigator97.KeyDown(var Key: Word; Shift: TShiftState);
var
        NewFocus: TNavigateBtn;
        OldFocus: TNavigateBtn;
begin
        OldFocus:=FocusedButton;
        case Key of
        VK_RIGHT: begin
                        NewFocus:=FocusedButton;
                        repeat
                                if NewFocus<High(Buttons) then
                                        NewFocus:=Succ(NewFocus);
                        until (NewFocus=High(Buttons)) or (Buttons[NewFocus].Visible);
                        if NewFocus<>FocusedButton then begin
                                FocusedButton:=NewFocus;
                                Buttons[OldFocus].Invalidate;
                                Buttons[FocusedButton].Invalidate;
                        end;
                end;
        VK_LEFT: begin
                        NewFocus:=FocusedButton;
                        repeat
                                if NewFocus>Low(Buttons) then
                                        NewFocus:=Pred(NewFocus);
                        until (NewFocus=Low(Buttons)) or (Buttons[NewFocus].Visible);
                        if NewFocus<>FocusedButton then begin
                                FocusedButton:=NewFocus;
                                Buttons[OldFocus].Invalidate;
                                Buttons[FocusedButton].Invalidate;
                        end;
                end;
        VK_SPACE:
                if Buttons[FocusedButton].Enabled then
                        Buttons[FocusedButton].Click;
        end;
end;

procedure TDBNavigator97.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
        Message.Result:=DLGC_WANTARROWS;
end;

procedure TDBNavigator97.DataChanged;
var
        UpEnable,DnEnable: Boolean;
begin
        UpEnable:=Enabled and FDataLink.Active and not FDataLink.DataSet.BOF;
        DnEnable:=Enabled and FDataLink.Active and not FDataLink.DataSet.EOF;
        Buttons[nbFirst].Enabled:=UpEnable and (nbFirst in EnabledButtons);
        Buttons[nbPrior].Enabled:=UpEnable and (nbPrior in EnabledButtons);
        Buttons[nbNext].Enabled:=DnEnable and (nbNext in EnabledButtons);
        Buttons[nbLast].Enabled:=DnEnable and (nbLast in EnabledButtons);
        Buttons[nbDelete].Enabled:=Enabled and FDataLink.Active and     FDataLink.DataSet.CanModify and
                        (not (FDataLink.DataSet.BOF and FDataLink.DataSet.EOF)) and (nbDelete in EnabledButtons);
end;

procedure TDBNavigator97.EditingChanged;
var
        CanModify: Boolean;
begin
        CanModify:=Enabled and FDataLink.Active and FDataLink.DataSet.CanModify;
        Buttons[nbInsert].Enabled:=CanModify and (nbInsert in EnabledButtons);
        Buttons[nbEdit].Enabled:=CanModify and not FDataLink.Editing and (nbEdit in EnabledButtons);
        Buttons[nbPost].Enabled:=CanModify and FDataLink.Editing and (nbPost in EnabledButtons);
        Buttons[nbCancel].Enabled:=CanModify and FDataLink.Editing and (nbCancel in EnabledButtons);
        Buttons[nbRefresh].Enabled:=not (FDataLink.DataSet is TQuery) and (nbRefresh in EnabledButtons);
end;

procedure TDBNavigator97.ActiveChanged;
var
        I: TNavigateBtn;
begin
        if not (Enabled and FDataLink.Active) then
                for I:=Low(Buttons) to High(Buttons) do
                        Buttons[I].Enabled:=False
        else begin
                DataChanged;
                EditingChanged;
        end;
end;

procedure TDBNavigator97.CMEnabledChanged(var Message: TMessage);
begin
        inherited;
        if not (csLoading in ComponentState) then
                ActiveChanged;
end;

procedure TDBNavigator97.SetDataSource(Value: TDataSource);
begin
        FDataLink.DataSource:=Value;
        if not (csLoading in ComponentState) then
                ActiveChanged;
        if Value<>nil then
                Value.FreeNotification(Self);
end;

function TDBNavigator97.GetDataSource: TDataSource;
begin
        Result:=FDataLink.DataSource;
end;

procedure TDBNavigator97.Loaded;
var
        W,H: Integer;
begin
        inherited;
        W:=Width;
        H:=Height;
        AdjustSize (W,H);
        if (W<>Width) or (H<>Height) then
                inherited SetBounds (Left,Top,W,H);
        InitHints;
        InitCaptions;
        InitFont;
        InitGlyphNumber;
        ActiveChanged;
end;

{TNavButton97}

destructor TNavButton97.Destroy;
begin
        if FRepeatTimer<>nil then
                FRepeatTimer.Free;
        inherited;
end;

procedure TNavButton97.MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
begin
        inherited;
        if nsAllowTimer in FNavStyle then       begin
                if FRepeatTimer=nil then
                        FRepeatTimer:=TTimer.Create(Self);
                FRepeatTimer.OnTimer:=TimerExpired;
                FRepeatTimer.Interval:=InitRepeatPause;
                FRepeatTimer.Enabled :=True;
        end;
end;

procedure TNavButton97.MouseUp(Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
begin
        inherited MouseUp (Button,Shift,X,Y);
        if FRepeatTimer<>nil then
                FRepeatTimer.Enabled :=False;
end;

procedure TNavButton97.TimerExpired(Sender: TObject);
begin
        FRepeatTimer.Interval:=RepeatPause;
        if (FState=bsDown) and MouseCapture then
                try
                        Click;
                except
                        FRepeatTimer.Enabled:=False;
                        raise;
                end;
end;

procedure TNavButton97.Paint;
var
        R: TRect;
begin
        inherited Paint;
        if (GetFocus=Parent.Handle) and (FIndex=TDBNavigator97(Owner).FocusedButton) then       begin
                R:=Bounds(0,0,Width,Height);
                InflateRect(R,-3,-3);
                if FState=bsDown then
                        OffsetRect(R,1,1);
                DrawFocusRect(Canvas.Handle,R);
        end;
end;

{TNavDataLink97}

constructor TNavDataLink97.Create(ANav: TDBNavigator97);
begin
        inherited Create;
        FNavigator:=ANav;
end;

destructor TNavDataLink97.Destroy;
begin
        FNavigator:=nil;
        inherited Destroy;
end;

procedure TNavDataLink97.EditingChanged;
begin
        if FNavigator<>nil then
                FNavigator.EditingChanged;
end;

procedure TNavDataLink97.DataSetChanged;
begin
        if FNavigator<>nil then
                FNavigator.DataChanged;
end;

procedure TNavDataLink97.ActiveChanged;
begin
        if FNavigator<>nil then
                FNavigator.ActiveChanged;
end;


procedure Register;
begin
        RegisterComponents('Toolbar97',[TDBNavigator97]);
end;

end.
